Index: trunk/Mars/resmc/MirrorReflectivity_Lustermann_FACT_bearbeitet.txt
===================================================================
--- trunk/Mars/resmc/MirrorReflectivity_Lustermann_FACT_bearbeitet.txt	(revision 15144)
+++ trunk/Mars/resmc/MirrorReflectivity_Lustermann_FACT_bearbeitet.txt	(revision 15144)
@@ -0,0 +1,603 @@
+ 200 0.5271       
+# 201 0.5420       
+# 202 0.5569       
+# 203 0.5714       
+# 204 0.5852       
+ 205 0.5988       
+# 206 0.6117       
+# 207 0.6240       
+# 208 0.6355       
+# 209 0.6465       
+ 210 0.6569       
+# 211 0.6665       
+# 212 0.6755       
+# 213 0.6840       
+# 214 0.6916       
+ 215 0.6987       
+# 216 0.7053       
+# 217 0.7111       
+# 218 0.7166       
+# 219 0.7216       
+ 220 0.7260       
+# 221 0.7302       
+# 222 0.7336       
+# 223 0.7368       
+# 224 0.7397       
+ 225 0.7423       
+# 226 0.7446       
+# 227 0.7465       
+# 228 0.7484       
+# 229 0.7498       
+ 230 0.7509       
+# 231 0.7518       
+# 232 0.7527       
+# 233 0.7532       
+# 234 0.7534       
+# 235 0.7535       
+# 236 0.7532       
+# 237 0.7529       
+# 238 0.7525       
+ 239 0.7517       
+# 240 0.7509       
+# 241 0.7499       
+# 242 0.7486       
+# 243 0.7472       
+ 244 0.7458       
+# 245 0.7442       
+# 246 0.7424       
+# 247 0.7405       
+# 248 0.7385       
+ 249 0.7365       
+# 250 0.7343       
+# 251 0.7322       
+# 252 0.7297       
+# 253 0.7273       
+ 254 0.7250       
+# 255 0.7226       
+# 256 0.7204       
+# 257 0.7179       
+# 258 0.7156       
+ 259 0.7134       
+# 260 0.7113       
+# 261 0.7093       
+# 262 0.7074       
+# 263 0.7056       
+ 264 0.7039       
+# 265 0.7023       
+# 266 0.7009       
+# 267 0.6995       
+# 268 0.6984       
+# 269 0.6976       
+# 270 0.6968       
+# 271 0.6963       
+# 272 0.6960       
+ 273 0.6961       
+# 274 0.6964       
+# 275 0.6967       
+# 276 0.6972       
+# 277 0.6981       
+ 278 0.6991       
+# 279 0.7003       
+# 280 0.7019       
+# 281 0.7036       
+# 282 0.7055       
+ 283 0.7075       
+# 284 0.7098       
+# 285 0.7123       
+# 286 0.7149       
+# 287 0.7174       
+ 288 0.7202       
+# 289 0.7233       
+# 290 0.7265       
+# 291 0.7295       
+# 292 0.7328       
+ 293 0.7361       
+# 294 0.7395       
+# 295 0.7430       
+# 296 0.7464       
+# 297 0.7500       
+ 298 0.7534       
+# 299 0.7568       
+# 300 0.7605       
+# 301 0.7641       
+# 302 0.7673       
+# 303 0.7707       
+# 304 0.7743       
+# 305 0.7777       
+# 306 0.7812       
+ 307 0.7846       
+# 308 0.7879       
+# 309 0.7912       
+# 310 0.7944       
+# 311 0.7975       
+ 312 0.8007       
+# 313 0.8037       
+# 314 0.8065       
+# 315 0.8095       
+# 316 0.8124       
+ 317 0.8152       
+# 318 0.8161       
+# 319 0.8180       
+# 320 0.8207       
+# 321 0.8232       
+ 322 0.8255       
+# 323 0.8275       
+# 324 0.8302       
+# 325 0.8325       
+# 326 0.8346       
+ 327 0.8368       
+# 328 0.8390       
+# 329 0.8412       
+# 330 0.8429       
+# 331 0.8448       
+ 332 0.8466       
+# 333 0.8484       
+# 334 0.8501       
+# 335 0.8519       
+# 336 0.8535       
+# 337 0.8553       
+# 338 0.8569       
+# 339 0.8583       
+# 340 0.8597       
+ 341 0.8610       
+# 342 0.8626       
+# 343 0.8636       
+# 344 0.8648       
+# 345 0.8662       
+ 346 0.8674       
+# 347 0.8683       
+# 348 0.8695       
+# 349 0.8706       
+# 350 0.8716       
+ 351 0.8726       
+# 352 0.8737       
+# 353 0.8747       
+# 354 0.8755       
+# 355 0.8766       
+ 356 0.8772       
+# 357 0.8782       
+# 358 0.8787       
+# 359 0.8798       
+# 360 0.8804       
+ 361 0.8810       
+# 362 0.8818       
+# 363 0.8823       
+# 364 0.8828       
+# 365 0.8836       
+ 366 0.8842       
+# 367 0.8851       
+# 368 0.8851       
+# 369 0.8857       
+# 370 0.8864       
+# 371 0.8872       
+# 372 0.8876       
+# 373 0.8879       
+# 374 0.8882       
+ 375 0.8886       
+# 376 0.8890       
+# 377 0.8893       
+# 378 0.8897       
+# 379 0.8912       
+ 380 0.8912       
+# 381 0.8916       
+# 382 0.8921       
+# 383 0.8922       
+# 384 0.8927       
+ 385 0.8930       
+# 386 0.8931       
+# 387 0.8935       
+# 388 0.8936       
+# 389 0.8940       
+ 390 0.8938       
+# 391 0.8945       
+# 392 0.8946       
+# 393 0.8948       
+# 394 0.8951       
+ 395 0.8949       
+# 396 0.8952       
+# 397 0.8955       
+# 398 0.8956       
+# 399 0.8958       
+ 400 0.8958       
+# 401 0.8958       
+# 402 0.8960       
+# 403 0.8962       
+# 404 0.8963       
+# 405 0.8963       
+# 406 0.8965       
+# 407 0.8965       
+# 408 0.8966       
+ 409 0.8965       
+# 410 0.8968       
+# 411 0.8967       
+# 412 0.8970       
+# 413 0.8968       
+ 414 0.8966       
+# 415 0.8965       
+# 416 0.8967       
+# 417 0.8967       
+# 418 0.8967       
+ 419 0.8967       
+# 420 0.8967       
+# 421 0.8968       
+# 422 0.8965       
+# 423 0.8966       
+ 424 0.8966       
+# 425 0.8965       
+# 426 0.8965       
+# 427 0.8965       
+# 428 0.8962       
+ 429 0.8962       
+# 430 0.8960       
+# 431 0.8959       
+# 432 0.8957       
+# 433 0.8958       
+ 434 0.8957       
+# 435 0.8957       
+# 436 0.8955       
+# 437 0.8954       
+# 438 0.8951       
+# 439 0.8951       
+# 440 0.8949       
+# 441 0.8947       
+# 442 0.8944       
+ 443 0.8941       
+# 444 0.8941       
+# 445 0.8939       
+# 446 0.8939       
+# 447 0.8939       
+ 448 0.8938       
+# 449 0.8938       
+# 450 0.8938       
+# 451 0.8939       
+# 452 0.8940       
+ 453 0.8940       
+# 454 0.8942       
+# 455 0.8943       
+# 456 0.8943       
+# 457 0.8944       
+ 458 0.8942       
+# 459 0.8943       
+# 460 0.8942       
+# 461 0.8943       
+# 462 0.8943       
+ 463 0.8940       
+# 464 0.8937       
+# 465 0.8934       
+# 466 0.8931       
+# 467 0.8929       
+ 468 0.8927       
+# 469 0.8924       
+# 470 0.8920       
+# 471 0.8917       
+# 472 0.8912       
+# 473 0.8908       
+# 474 0.8903       
+# 475 0.8898       
+# 476 0.8894       
+ 477 0.8890       
+# 478 0.8885       
+# 479 0.8880       
+# 480 0.8875       
+# 481 0.8869       
+ 482 0.8863       
+# 483 0.8857       
+# 484 0.8851       
+# 485 0.8846       
+# 486 0.8843       
+ 487 0.8840       
+# 488 0.8838       
+# 489 0.8837       
+# 490 0.8836       
+# 491 0.8834       
+ 492 0.8834       
+# 493 0.8834       
+# 494 0.8833       
+# 495 0.8833       
+# 496 0.8832       
+ 497 0.8831       
+# 498 0.8830       
+# 499 0.8829       
+# 500 0.8828       
+# 501 0.8828       
+ 502 0.8826       
+# 503 0.8824       
+# 504 0.8821       
+# 505 0.8818       
+# 506 0.8814       
+# 507 0.8810       
+# 508 0.8806       
+# 509 0.8801       
+# 510 0.8796       
+ 511 0.8793       
+# 512 0.8790       
+# 513 0.8787       
+# 514 0.8782       
+# 515 0.8776       
+ 516 0.8771       
+# 517 0.8766       
+# 518 0.8759       
+# 519 0.8754       
+# 520 0.8750       
+ 521 0.8745       
+# 522 0.8742       
+# 523 0.8738       
+# 524 0.8733       
+# 525 0.8729       
+ 526 0.8723       
+# 527 0.8718       
+# 528 0.8711       
+# 529 0.8705       
+# 530 0.8700       
+ 531 0.8696       
+# 532 0.8692       
+# 533 0.8688       
+# 534 0.8685       
+# 535 0.8679       
+ 536 0.8674       
+# 537 0.8668       
+# 538 0.8662       
+# 539 0.8656       
+# 540 0.8650       
+# 541 0.8645       
+# 542 0.8641       
+# 543 0.8638       
+# 544 0.8632       
+ 545 0.8627       
+# 546 0.8620       
+# 547 0.8616       
+# 548 0.8610       
+# 549 0.8603       
+ 550 0.8598       
+# 551 0.8594       
+# 552 0.8587       
+# 553 0.8583       
+# 554 0.8578       
+ 555 0.8574       
+# 556 0.8569       
+# 557 0.8563       
+# 558 0.8557       
+# 559 0.8551       
+ 560 0.8545       
+# 561 0.8541       
+# 562 0.8536       
+# 563 0.8530       
+# 564 0.8524       
+ 565 0.8518       
+# 566 0.8513       
+# 567 0.8508       
+# 568 0.8500       
+# 569 0.8496       
+ 570 0.8490       
+# 571 0.8484       
+# 572 0.8480       
+# 573 0.8475       
+# 574 0.8467       
+# 575 0.8463       
+# 576 0.8459       
+# 577 0.8452       
+# 578 0.8446       
+ 579 0.8441       
+# 580 0.8435       
+# 581 0.8428       
+# 582 0.8422       
+# 583 0.8416       
+ 584 0.8410       
+# 585 0.8407       
+# 586 0.8401       
+# 587 0.8396       
+# 588 0.8392       
+ 589 0.8386       
+# 590 0.8379       
+# 591 0.8375       
+# 592 0.8366       
+# 593 0.8358       
+ 594 0.8354       
+# 595 0.8345       
+# 596 0.8339       
+# 597 0.8334       
+# 598 0.8330       
+ 599 0.8325       
+# 600 0.8322       
+# 601 0.8316       
+# 602 0.8311       
+# 603 0.8305       
+ 604 0.8298       
+# 605 0.8291       
+# 606 0.8283       
+# 607 0.8276       
+# 608 0.8270       
+# 609 0.8262       
+# 610 0.8256       
+# 611 0.8249       
+# 612 0.8246       
+ 613 0.8241       
+# 614 0.8252       
+# 615 0.8367       
+# 616 0.8225       
+# 617 0.8220       
+ 618 0.8216       
+# 619 0.8209       
+# 620 0.8203       
+# 621 0.8195       
+# 622 0.8188       
+ 623 0.8179       
+# 624 0.8171       
+# 625 0.8166       
+# 626 0.8159       
+# 627 0.8156       
+ 628 0.8151       
+# 629 0.8145       
+# 630 0.8140       
+# 631 0.8135       
+# 632 0.8130       
+ 633 0.8125       
+# 634 0.8118       
+# 635 0.8111       
+# 636 0.8104       
+# 637 0.8096       
+ 638 0.8089       
+# 639 0.8082       
+# 640 0.8075       
+# 641 0.8068       
+# 642 0.8064       
+# 643 0.8058       
+# 644 0.8053       
+# 645 0.8047       
+# 646 0.8042       
+ 647 0.8037       
+# 648 0.8031       
+# 649 0.8025       
+# 650 0.8019       
+# 651 0.8011       
+ 652 0.8005       
+# 653 0.7997       
+# 654 0.7992       
+# 655 0.7986       
+# 656 0.7979       
+ 657 0.7972       
+# 658 0.7965       
+# 659 0.7961       
+# 660 0.7956       
+# 661 0.7949       
+ 662 0.7944       
+# 663 0.7937       
+# 664 0.7931       
+# 665 0.7925       
+# 666 0.7918       
+ 667 0.7913       
+# 668 0.7907       
+# 669 0.7901       
+# 670 0.7895       
+# 671 0.7889       
+ 672 0.7883       
+# 673 0.7878       
+# 674 0.7872       
+# 675 0.7866       
+# 676 0.7860       
+# 677 0.7854       
+# 678 0.7848       
+# 679 0.7842       
+# 680 0.7835       
+ 681 0.7827       
+# 682 0.7820       
+# 683 0.7815       
+# 684 0.7809       
+# 685 0.7803       
+ 686 0.7798       
+# 687 0.7792       
+# 688 0.7788       
+# 689 0.7782       
+# 690 0.7777       
+ 691 0.7771       
+# 692 0.7766       
+# 693 0.7759       
+# 694 0.7752       
+# 695 0.7745       
+ 696 0.7740       
+# 697 0.7734       
+# 698 0.7727       
+# 699 0.7720       
+# 700 0.7714       
+ 701 0.7708       
+# 702 0.7702       
+# 703 0.7696       
+# 704 0.7692       
+# 705 0.7689       
+ 706 0.7682       
+# 707 0.7677       
+# 708 0.7673       
+# 709 0.7667       
+# 710 0.7661       
+# 711 0.7655       
+# 712 0.7649       
+# 713 0.7641       
+# 714 0.7634       
+ 715 0.7629       
+# 716 0.7621       
+# 717 0.7614       
+# 718 0.7609       
+# 719 0.7603       
+ 720 0.7599       
+# 721 0.7595       
+# 722 0.7590       
+# 723 0.7586       
+# 724 0.7583       
+ 725 0.7578       
+# 726 0.7572       
+# 727 0.7568       
+# 728 0.7563       
+# 729 0.7558       
+ 730 0.7552       
+# 731 0.7545       
+# 732 0.7538       
+# 733 0.7532       
+# 734 0.7524       
+ 735 0.7518       
+# 736 0.7510       
+# 737 0.7505       
+# 738 0.7501       
+# 739 0.7496       
+ 740 0.7492       
+# 741 0.7488       
+# 742 0.7483       
+# 743 0.7481       
+# 744 0.7478       
+# 745 0.7475       
+# 746 0.7471       
+# 747 0.7467       
+# 748 0.7462       
+ 749 0.7457       
+# 750 0.7453       
+# 751 0.7447       
+# 752 0.7441       
+# 753 0.7435       
+ 754 0.7428       
+# 755 0.7421       
+# 756 0.7416       
+# 757 0.7412       
+# 758 0.7405       
+ 759 0.7399       
+# 760 0.7395       
+# 761 0.7390       
+# 762 0.7387       
+# 763 0.7384       
+ 764 0.7382       
+# 765 0.7380       
+# 766 0.7377       
+# 767 0.7374       
+# 768 0.7371       
+ 769 0.7368       
+# 770 0.7367       
+# 771 0.7362       
+# 772 0.7358       
+# 773 0.7354       
+ 774 0.7351       
+# 775 0.7346       
+# 776 0.7342       
+# 777 0.7337       
+# 778 0.7334       
+# 779 0.7327       
+# 780 0.7324       
+# 781 0.7319       
+# 782 0.7316       
+ 783 0.7312       
+# 784 0.7309       
+# 785 0.7306       
+# 786 0.7304       
+# 787 0.7302       
+ 788 0.7300       
+# 789 0.7298       
+# 790 0.7298       
+# 791 0.7296       
+# 792 0.7295       
+ 793 0.7292       
+# 794 0.7290       
+# 795 0.7290       
+# 796 0.7288       
+# 797 0.7286       
+ 798 0.7286       
+# 799 0.7281       
+ 800 0.7282
+ 900 0.685
+950 0.6634
Index: trunk/Mars/resmc/Transmittance_1439Cones_FACT_bearbeitet.txt
===================================================================
--- trunk/Mars/resmc/Transmittance_1439Cones_FACT_bearbeitet.txt	(revision 15144)
+++ trunk/Mars/resmc/Transmittance_1439Cones_FACT_bearbeitet.txt	(revision 15144)
@@ -0,0 +1,44 @@
+# several points are outcomment, for a faster calculation of the spline
+250    0.0005566
+#260    0.00081966
+270    0.00061284
+280    0.0030381
+290    0.020164
+300    0.090906
+310    0.239483
+320    0.422324
+330    0.555866
+340    0.645322
+350    0.709289
+360    0.757315
+370    0.79624
+380    0.824558
+390    0.842468
+400    0.853939
+#410    0.861924
+420    0.866997
+#430    0.871904
+440    0.875743
+#450    0.878966
+460    0.881858
+#470    0.883873
+480    0.88636
+490    0.889237
+500    0.890949
+#510    0.892239
+#520    0.893734
+530    0.895242
+#540    0.896486
+#550    0.89755
+560    0.898537
+#570    0.898963
+#580    0.899302
+590    0.899906
+600    0.900801
+700    0.900
+# artificial points for ceres
+800    0.9
+900    0.9
+950    0.9
+
+
Index: trunk/Mars/resmc/dwarf-reflectivity.txt
===================================================================
--- trunk/Mars/resmc/dwarf-reflectivity.txt	(revision 15143)
+++ trunk/Mars/resmc/dwarf-reflectivity.txt	(revision 15144)
@@ -1,2 +1,3 @@
+280 0.810
 290 0.857
 310 0.893
Index: trunk/Mars/resmc/fact-cones-angular-acceptance.txt
===================================================================
--- trunk/Mars/resmc/fact-cones-angular-acceptance.txt	(revision 15144)
+++ trunk/Mars/resmc/fact-cones-angular-acceptance.txt	(revision 15144)
@@ -0,0 +1,43 @@
+0.0 0.937746
+#0.5 0.937746
+#1.5 0.937418
+2.5 0.93976
+#3.5 0.936127
+#4.5 0.935089
+5.5 0.936749
+#6.5 0.934326
+#7.5 0.930171
+8.5 0.928966
+#9.5 0.920311
+#10.5 0.922695
+11.5 0.924916
+12.5 0.913469
+13.5 0.908584
+14.5 0.8928
+15.5 0.876443
+#16.5 0.838244
+17.5 0.809582
+#18.5 0.766141
+19.5 0.734286
+#20.5 0.675619
+21.5 0.605115
+#22.5 0.557933
+23.5 0.510183
+#24.5 0.427758
+25.5 0.376363
+#26.5 0.347437
+27.5 0.281052
+28.5 0.220598
+#29.5 0.201032
+30.5 0.134495
+31.5 0.10123
+#32.5 0.0761607
+33.5 0.0491442
+#34.5 0.0322082
+35.5 0.012836
+#36.5 0.00400929
+37.5 0.00129465
+#38.5 0.000650586
+39.5 0
+40.5 0
+88.5 0
Index: trunk/Mars/resmc/fact-pde-1.4V.txt
===================================================================
--- trunk/Mars/resmc/fact-pde-1.4V.txt	(revision 15144)
+++ trunk/Mars/resmc/fact-pde-1.4V.txt	(revision 15144)
@@ -0,0 +1,56 @@
+# several points are outcomment, for a faster calculation of the spline
+# 2 artificial points
+280 0
+290 0
+#
+320 0.121739
+360 0.215913
+369.655 0.237265
+380.359 0.26367
+392.682 0.285362
+400 0.298
+410 0.313043
+420 0.329652
+429.652 0.343207
+440 0.352696
+450 0.357478
+460 0.359304
+469.397 0.359992
+480 0.358696
+487.328 0.355867
+500 0.352348
+#509.192 0.345273
+520 0.336435
+#530 0.32487
+540 0.316
+#550 0.304348
+560 0.29287
+#570 0.282609
+580 0.270783
+#590 0.259739
+600 0.247565
+610 0.237043
+616.74 0.227516
+626.822 0.218219
+636.905 0.209956
+646.987 0.199626
+#660 0.190609
+#670 0.182522
+680 0.176348
+#690 0.168087
+#700 0.160609
+710 0.154609
+#720 0.147739
+#730 0.140522
+740 0.132696
+#750 0.127304
+#760 0.12
+770 0.113739
+#780 0.10713
+790 0.100696
+846.399 0.065341
+# artificial points
+880 0.01
+890 0.001
+900 0
+950 0